#include <FL/Fl.H>
#include <FL/Fl_Double_Window.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Text_Buffer.H>
#include <FL/Fl_Text_Editor.H>

static Fl_Double_Window *main_win=(Fl_Double_Window *)0;

static Fl_Button *bt1=(Fl_Button *)0;
static Fl_Button *bt2=(Fl_Button *)0;
static Fl_Button *bt3=(Fl_Button *)0;
static Fl_Button *bt4=(Fl_Button *)0;
static Fl_Button *quit_bt=(Fl_Button *)0;

static Fl_Text_Editor *edit_1=(Fl_Text_Editor *)0;
static Fl_Text_Buffer *textbuf = 0;


static void cb_quit_bt(Fl_Button*, void*) {
  main_win->hide();
}

int main(int argc, char **argv) {
  main_win = new Fl_Double_Window(669, 459, "Test Editor Navigation");
  main_win->begin();

  bt1 = new Fl_Button(20, 20, 75, 35, "Button 1");
  bt2 = new Fl_Button(203, 20, 75, 35, "Button 2");
  bt3 = new Fl_Button(386, 20, 75, 35, "Button 3");
  bt4 = new Fl_Button(570, 20, 75, 35, "Button 4");

  textbuf = new Fl_Text_Buffer;
  edit_1 = new Fl_Text_Editor(20, 70, 625, 315);
  edit_1->buffer(textbuf);
  edit_1->textfont(FL_COURIER);
  edit_1->textsize(14);

  /* Tell the editor to ignore all tabs, if this is the desired behaviour */
  /* edit_1->add_key_binding (FL_Tab, FL_TEXT_EDITOR_ANY_STATE, Fl_Text_Editor::kf_ignore); */

  /* As a more complex option, the following allows the editor to ignore plain tabs, but treat
     a CTRL+TAB combination as a regular tab. In this way, the user can navigate around
     using TAB (forwards navigation) and SHIFT+TAB (reverse movement) but can also still
     insert tabs into the editor text by typing CTRL+TAB if necessary.
     Tested on WIN32 and worked as expected. Note that special handling of ALT+TAB is not shown
     here because (at least on WIN32) an ALT+TAB combo is never delivered to the application
     anyway, it gets eaten by the WM first.
   */
  /* Tell the editor to ignore any "undecorated" tab keys,
     so that TAB navigation can work */
  edit_1->add_key_binding (FL_Tab, 0, Fl_Text_Editor::kf_ignore);

  /* tell the editor to treat CTRL+TAB as if it were a regular tab,
     so that the user can type tabs into the editor if they need to. */
  edit_1->add_key_binding (FL_Tab, FL_CTRL, Fl_Text_Editor::kf_default);

  quit_bt = new Fl_Button(570, 410, 75, 35, "Quit");
  quit_bt->callback((Fl_Callback*)cb_quit_bt);

  main_win->end();

  main_win->show(argc, argv);
  return Fl::run();
} // main

// end of file
